package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.LowLevelApi
import ru.landgrafhomyak.serdha.api.v0.ddl.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.ColumnType
import ru.landgrafhomyak.serdha.api.v0.ddl.Table
import ru.landgrafhomyak.serdha.api.v0.runtime.ParametersSetter
import ru.landgrafhomyak.serdha.api.v0.runtime._ParametersSetter

@Suppress("ClassName")
public interface _CommonQueryMethods<QueryUserExtension : Any> {
	public val types: ColumnType.Builder

	public fun <SelectedTableUserExtension : Any> selectTable(t: Table<SelectedTableUserExtension, *>): SelectedTable<SelectedTableUserExtension, QueryUserExtension>

	public interface CanBeSubquery<@Suppress("unused") SelectedQueryUserExtension : Any>

	public interface SubqueryParametersSetter<SubqueryUserExtension : Any, QueryUserExtension : Any> : ParametersSetter<SubqueryUserExtension> {
		public operator fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> set(c: InputParam<RuntimeType, DatabaseType, QueryUserExtension>, value: Expression<RuntimeType, DatabaseType, QueryUserExtension>)
	}

	public fun <SubqueryUserExtension : Any> selectQuery(q: CanBeSubquery<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedTable<SubqueryUserExtension, QueryUserExtension>

	public class SelectedInsert<SubqueryUserExtension : Any, QueryUserExtension : Any>(
		public val inserted: SelectedTable<SubqueryUserExtension, QueryUserExtension>,
		public val updated: SelectedTable<SubqueryUserExtension, QueryUserExtension>
	)

	public fun <SubqueryUserExtension : Any> selectInsert(q: Insert.InsertParams<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedInsert<SubqueryUserExtension, QueryUserExtension>

	@Suppress("FunctionName")
	@LowLevelApi
	public fun <SubqueryUserExtension : Any> _selectInsert(
		q: Insert.InsertFromQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (_ParametersSetter._Multi<InsertCreator.InsertParams.DataParam<SubqueryUserExtension>, Nothing>) -> Unit
	): SelectedInsert<SubqueryUserExtension, QueryUserExtension>

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any> selectInsertOne(
		q: Insert.InsertFromQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (ParametersSetter<InsertCreator.InsertParams.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedInsert<SubqueryUserExtension, QueryUserExtension> =
		this._selectInsert(q, p, r)

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any, T> selectInsertMulti(
		q: Insert.InsertFromQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		data: Iterable<T>,
		r: (T, ParametersSetter<InsertCreator.InsertParams.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedInsert<SubqueryUserExtension, QueryUserExtension> =
		this._selectInsert(q, p) { rr -> for (e in data) r(e, rr) }

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> param(name: String, type: DatabaseType): InputParam<RuntimeType, DatabaseType, QueryUserExtension>

	public val expressionBuilder: Expression.Builder<QueryUserExtension>

	public interface _Returning<QueryUserExtension : Any> {
		public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> returnExpression(expression: Expression<RuntimeType, DatabaseType, QueryUserExtension>): Column<RuntimeType, DatabaseType, QueryUserExtension>

		public val isDistinct: Boolean

		public fun orderBy(order: Select.Order, vararg columns: Expression<*, *, QueryUserExtension>)

		public fun groupBy(vararg columns: Expression<*, *, QueryUserExtension>)
	}
}